<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMbrPrevMedicalScheme ArrayType
 * @subpackage Arrays
 */
class ArrayOfMbrPrevMedicalScheme extends AbstractStructArrayBase
{
    /**
     * The MbrPrevMedicalScheme
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MbrPrevMedicalScheme[]
     */
    public $MbrPrevMedicalScheme;
    /**
     * Constructor method for ArrayOfMbrPrevMedicalScheme
     * @uses ArrayOfMbrPrevMedicalScheme::setMbrPrevMedicalScheme()
     * @param \StructType\MbrPrevMedicalScheme[] $mbrPrevMedicalScheme
     */
    public function __construct(array $mbrPrevMedicalScheme = array())
    {
        $this
            ->setMbrPrevMedicalScheme($mbrPrevMedicalScheme);
    }
    /**
     * Get MbrPrevMedicalScheme value
     * @return \StructType\MbrPrevMedicalScheme[]|null
     */
    public function getMbrPrevMedicalScheme()
    {
        return $this->MbrPrevMedicalScheme;
    }
    /**
     * This method is responsible for validating the values passed to the setMbrPrevMedicalScheme method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMbrPrevMedicalScheme method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMbrPrevMedicalSchemeForArrayConstraintsFromSetMbrPrevMedicalScheme(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem) {
            // validation for constraint: itemType
            if (!$arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem instanceof \StructType\MbrPrevMedicalScheme) {
                $invalidValues[] = is_object($arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem) ? get_class($arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem) : sprintf('%s(%s)', gettype($arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem), var_export($arrayOfMbrPrevMedicalSchemeMbrPrevMedicalSchemeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MbrPrevMedicalScheme property can only contain items of type \StructType\MbrPrevMedicalScheme, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MbrPrevMedicalScheme value
     * @throws \InvalidArgumentException
     * @param \StructType\MbrPrevMedicalScheme[] $mbrPrevMedicalScheme
     * @return \ArrayType\ArrayOfMbrPrevMedicalScheme
     */
    public function setMbrPrevMedicalScheme(array $mbrPrevMedicalScheme = array())
    {
        // validation for constraint: array
        if ('' !== ($mbrPrevMedicalSchemeArrayErrorMessage = self::validateMbrPrevMedicalSchemeForArrayConstraintsFromSetMbrPrevMedicalScheme($mbrPrevMedicalScheme))) {
            throw new \InvalidArgumentException($mbrPrevMedicalSchemeArrayErrorMessage, __LINE__);
        }
        $this->MbrPrevMedicalScheme = $mbrPrevMedicalScheme;
        return $this;
    }
    /**
     * Add item to MbrPrevMedicalScheme value
     * @throws \InvalidArgumentException
     * @param \StructType\MbrPrevMedicalScheme $item
     * @return \ArrayType\ArrayOfMbrPrevMedicalScheme
     */
    public function addToMbrPrevMedicalScheme(\StructType\MbrPrevMedicalScheme $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MbrPrevMedicalScheme) {
            throw new \InvalidArgumentException(sprintf('The MbrPrevMedicalScheme property can only contain items of type \StructType\MbrPrevMedicalScheme, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MbrPrevMedicalScheme[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MbrPrevMedicalScheme|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MbrPrevMedicalScheme|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MbrPrevMedicalScheme|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MbrPrevMedicalScheme|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MbrPrevMedicalScheme|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MbrPrevMedicalScheme
     */
    public function getAttributeName()
    {
        return 'MbrPrevMedicalScheme';
    }
}
