<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMedicalHistoryQuestionaire ArrayType
 * @subpackage Arrays
 */
class ArrayOfMedicalHistoryQuestionaire extends AbstractStructArrayBase
{
    /**
     * The MedicalHistoryQuestionaire
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MedicalHistoryQuestionaire[]
     */
    public $MedicalHistoryQuestionaire;
    /**
     * Constructor method for ArrayOfMedicalHistoryQuestionaire
     * @uses ArrayOfMedicalHistoryQuestionaire::setMedicalHistoryQuestionaire()
     * @param \StructType\MedicalHistoryQuestionaire[] $medicalHistoryQuestionaire
     */
    public function __construct(array $medicalHistoryQuestionaire = array())
    {
        $this
            ->setMedicalHistoryQuestionaire($medicalHistoryQuestionaire);
    }
    /**
     * Get MedicalHistoryQuestionaire value
     * @return \StructType\MedicalHistoryQuestionaire[]|null
     */
    public function getMedicalHistoryQuestionaire()
    {
        return $this->MedicalHistoryQuestionaire;
    }
    /**
     * This method is responsible for validating the values passed to the setMedicalHistoryQuestionaire method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMedicalHistoryQuestionaire method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMedicalHistoryQuestionaireForArrayConstraintsFromSetMedicalHistoryQuestionaire(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem) {
            // validation for constraint: itemType
            if (!$arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem instanceof \StructType\MedicalHistoryQuestionaire) {
                $invalidValues[] = is_object($arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem) ? get_class($arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem) : sprintf('%s(%s)', gettype($arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem), var_export($arrayOfMedicalHistoryQuestionaireMedicalHistoryQuestionaireItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MedicalHistoryQuestionaire property can only contain items of type \StructType\MedicalHistoryQuestionaire, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MedicalHistoryQuestionaire value
     * @throws \InvalidArgumentException
     * @param \StructType\MedicalHistoryQuestionaire[] $medicalHistoryQuestionaire
     * @return \ArrayType\ArrayOfMedicalHistoryQuestionaire
     */
    public function setMedicalHistoryQuestionaire(array $medicalHistoryQuestionaire = array())
    {
        // validation for constraint: array
        if ('' !== ($medicalHistoryQuestionaireArrayErrorMessage = self::validateMedicalHistoryQuestionaireForArrayConstraintsFromSetMedicalHistoryQuestionaire($medicalHistoryQuestionaire))) {
            throw new \InvalidArgumentException($medicalHistoryQuestionaireArrayErrorMessage, __LINE__);
        }
        $this->MedicalHistoryQuestionaire = $medicalHistoryQuestionaire;
        return $this;
    }
    /**
     * Add item to MedicalHistoryQuestionaire value
     * @throws \InvalidArgumentException
     * @param \StructType\MedicalHistoryQuestionaire $item
     * @return \ArrayType\ArrayOfMedicalHistoryQuestionaire
     */
    public function addToMedicalHistoryQuestionaire(\StructType\MedicalHistoryQuestionaire $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MedicalHistoryQuestionaire) {
            throw new \InvalidArgumentException(sprintf('The MedicalHistoryQuestionaire property can only contain items of type \StructType\MedicalHistoryQuestionaire, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MedicalHistoryQuestionaire[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MedicalHistoryQuestionaire|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MedicalHistoryQuestionaire|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MedicalHistoryQuestionaire|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MedicalHistoryQuestionaire|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MedicalHistoryQuestionaire|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MedicalHistoryQuestionaire
     */
    public function getAttributeName()
    {
        return 'MedicalHistoryQuestionaire';
    }
}
