<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWaitingPeriod ArrayType
 * @subpackage Arrays
 */
class ArrayOfWaitingPeriod extends AbstractStructArrayBase
{
    /**
     * The WaitingPeriod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\WaitingPeriod[]
     */
    public $WaitingPeriod;
    /**
     * Constructor method for ArrayOfWaitingPeriod
     * @uses ArrayOfWaitingPeriod::setWaitingPeriod()
     * @param \StructType\WaitingPeriod[] $waitingPeriod
     */
    public function __construct(array $waitingPeriod = array())
    {
        $this
            ->setWaitingPeriod($waitingPeriod);
    }
    /**
     * Get WaitingPeriod value
     * @return \StructType\WaitingPeriod[]|null
     */
    public function getWaitingPeriod()
    {
        return $this->WaitingPeriod;
    }
    /**
     * This method is responsible for validating the values passed to the setWaitingPeriod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWaitingPeriod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWaitingPeriodForArrayConstraintsFromSetWaitingPeriod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWaitingPeriodWaitingPeriodItem) {
            // validation for constraint: itemType
            if (!$arrayOfWaitingPeriodWaitingPeriodItem instanceof \StructType\WaitingPeriod) {
                $invalidValues[] = is_object($arrayOfWaitingPeriodWaitingPeriodItem) ? get_class($arrayOfWaitingPeriodWaitingPeriodItem) : sprintf('%s(%s)', gettype($arrayOfWaitingPeriodWaitingPeriodItem), var_export($arrayOfWaitingPeriodWaitingPeriodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WaitingPeriod property can only contain items of type \StructType\WaitingPeriod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WaitingPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\WaitingPeriod[] $waitingPeriod
     * @return \ArrayType\ArrayOfWaitingPeriod
     */
    public function setWaitingPeriod(array $waitingPeriod = array())
    {
        // validation for constraint: array
        if ('' !== ($waitingPeriodArrayErrorMessage = self::validateWaitingPeriodForArrayConstraintsFromSetWaitingPeriod($waitingPeriod))) {
            throw new \InvalidArgumentException($waitingPeriodArrayErrorMessage, __LINE__);
        }
        $this->WaitingPeriod = $waitingPeriod;
        return $this;
    }
    /**
     * Add item to WaitingPeriod value
     * @throws \InvalidArgumentException
     * @param \StructType\WaitingPeriod $item
     * @return \ArrayType\ArrayOfWaitingPeriod
     */
    public function addToWaitingPeriod(\StructType\WaitingPeriod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WaitingPeriod) {
            throw new \InvalidArgumentException(sprintf('The WaitingPeriod property can only contain items of type \StructType\WaitingPeriod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WaitingPeriod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WaitingPeriod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WaitingPeriod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WaitingPeriod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WaitingPeriod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WaitingPeriod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WaitingPeriod
     */
    public function getAttributeName()
    {
        return 'WaitingPeriod';
    }
}
